Index: /java/main/src/main/java/com/framsticks/params/AccessOperations.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/AccessOperations.java	(revision 107)
@@ -99,4 +99,5 @@
 	public static Access loadAll(@Nullable final Access rootAccess, Source source, final Registry registry) {
 		final MultiParamLoader loader = new MultiParamLoader();
+		log.trace("loading all from {} into {}", source, rootAccess);
 		loader.setNewSource(source);
 		final LinkedList<Access> accessesStack = new LinkedList<>();
@@ -146,6 +147,11 @@
 
 							if (p instanceof ListParam) {
-								ListAccess listAccess = Casting.assertCast(ListAccess.class, registry.prepareAccess(p));
-								listAccess.select(a.get(p, Object.class));
+								ListAccess listAccess = Casting.assertCast(ListAccess.class, registry.prepareAccess(p, true));
+								Object list = a.get(p, Object.class);
+								if (list == null) {
+									list = listAccess.createAccessee();
+									a.set(p, list);
+								}
+								listAccess.select(list);
 								parent.set(new Pair<Access, CompositeParam>(listAccess, listAccess.prepareParamFor(Integer.toString(listAccess.getParamCount()))));
 
@@ -157,4 +163,5 @@
 
 					if (parent.get() == null) {
+						log.trace("{} cannot be placed in {}", name, a);
 						accessIterator.remove();
 					}
@@ -162,8 +169,8 @@
 
 				if (parent.get() == null) {
-					throw new FramsticksException().msg("failed to find place for loaded object").arg("name", name);
-				}
-
-				currentAccess.set(registry.prepareAccess(parent.get().second));
+					throw new FramsticksException().msg("failed to find place for loaded object").arg("name", name); //.arg("in", accessesStack);
+				}
+
+				currentAccess.set(registry.prepareAccess(parent.get().second, true));
 				Object object = parent.get().first.get(parent.get().second, Object.class);
 				if (object != null) {
@@ -200,5 +207,5 @@
 	}
 
-	public static void saveAll(Access access, Sink sink, Registry registry) {
+	public static <S extends Sink> S saveAll(Access access, S sink, Registry registry) {
 		if (access instanceof ObjectAccess) {
 			savePrimitives(access, sink);
@@ -209,6 +216,7 @@
 				continue;
 			}
-			saveAll(registry.prepareAccess(p).select(child), sink, registry);
-		}
+			saveAll(registry.prepareAccess(p, true).select(child), sink, registry);
+		}
+		return sink;
 	}
 
@@ -219,5 +227,5 @@
 				continue;
 			}
-			savePrimitives(registry.prepareAccess(p).select(child), sink);
+			savePrimitives(registry.prepareAccess(p, true).select(child), sink);
 		}
 	}
@@ -297,5 +305,5 @@
 					}
 
-					return registry.prepareAccess(result).select(objectAccess.get(result, Object.class));
+					return registry.prepareAccess(result, true).select(objectAccess.get(result, Object.class));
 				}
 			});
@@ -323,5 +331,7 @@
 			}
 			if ((param.getFlags() & ParamFlags.DONTLOAD) == 0) {
-				int retFlags = access.set((ValueParam) param, entry.value);
+				ValueParam valueParam = (ValueParam) param;
+				// Object object = valueParam.deserialize(entry.value, null,  Object.class);
+				int retFlags = access.set(valueParam, entry.value);
 				if ((retFlags & (PSET_HITMIN | PSET_HITMAX)) != 0) {
 					String which = ((retFlags & PSET_HITMIN) != 0) ? "small" : "big";
@@ -440,4 +450,5 @@
 	 */
 	public static <T, F> T convert(Class<T> toJavaClass, F from, Registry registry) {
+		log.trace("converting from {} to {}", from, toJavaClass);
 		if (toJavaClass.equals(from.getClass())) {
 			return toJavaClass.cast(from);
@@ -478,5 +489,5 @@
 
 				if (avp instanceof CompositeParam) {
-					assureEquality(registry.prepareAccess((CompositeParam) avp).select(oa), registry.prepareAccess((CompositeParam) bvp).select(ob), registry);
+					assureEquality(registry.prepareAccess((CompositeParam) avp, false).select(oa), registry.prepareAccess((CompositeParam) bvp, false).select(ob), registry);
 					continue;
 				}
Index: /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 107)
@@ -137,5 +137,5 @@
 				return new Iterator<Param>() {
 
-					protected ListIterator<Object> internal = list.listIterator();
+					protected final ListIterator<Object> internal = list.listIterator();
 
 					@Override
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 107)
@@ -42,5 +42,9 @@
 
 	public static FramsClass readFromStream(InputStream stream) {
-		return Loaders.loadFramsClass(new FileSource(stream));
+		return readFromSource(new FileSource(stream));
+	}
+
+	public static FramsClass readFromSource(Source source) {
+		return Loaders.loadFramsClass(source);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/FreeAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FreeAccess.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/params/FreeAccess.java	(revision 107)
@@ -0,0 +1,181 @@
+package com.framsticks.params;
+
+import java.util.Iterator;
+import java.util.Map;
+
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.params.types.UniversalParam;
+import com.framsticks.util.UnimplementedException;
+
+public class FreeAccess implements ObjectAccess {
+
+	protected FreeObject object;
+
+	protected final String typeName;
+
+	/**
+	 * @param typeName
+	 */
+	public FreeAccess(String typeName) {
+		this.typeName = typeName;
+	}
+
+	@Override
+	public Param getParam(int i) {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public Param getParam(String id) {
+		return Param.build().type(UniversalParam.class).idAndName(id).finish();
+	}
+
+	@Override
+	public int getParamCount() {
+		return object.size();
+	}
+
+	@Override
+	public Iterable<Param> getParams() {
+		return new Iterable<Param>() {
+
+			@Override
+			public Iterator<Param> iterator() {
+				return new Iterator<Param>() {
+
+					protected final Iterator<Map.Entry<String, Object>> internal = object.iterator();
+
+					@Override
+					public boolean hasNext() {
+						return internal.hasNext();
+					}
+
+					@Override
+					public Param next() {
+						return Param.build().idAndName(internal.next().getKey()).type(UniversalParam.class).finish(Param.class);
+					}
+
+					@Override
+					public void remove() {
+						throw new UnimplementedException().msg("remove element from FreeAccess").arg("access", FreeAccess.this);
+					}
+				};
+			}
+		};
+	}
+
+	@Override
+	public String getTypeId() {
+		return typeName;
+	}
+
+	@Override
+	public Object call(String id, Object... arguments) {
+		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("id", id);
+	}
+
+	@Override
+	public Object call(ProcedureParam param, Object... arguments) {
+		throw new InvalidOperationException().msg("properties access does not support calling methods").arg("param", param);
+	}
+
+	@Override
+	public <T> T get(int i, Class<T> type) {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public <T> T get(String id, Class<T> type) {
+		return object.get(id, type);
+	}
+
+	@Override
+	public <T> T get(ValueParam param, Class<T> type) {
+		return get(param.getId(), type);
+	}
+
+	@Override
+	public <T> int set(int i, T value) {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public <T> int set(String id, T value) {
+		object.set(id, (value instanceof String) ? ParamsUtil.deserialize((String) value) : value);
+		return 0;
+	}
+
+	@Override
+	public <T> int set(ValueParam param, T value) {
+		return set(param.getId(), value);
+	}
+
+	@Override
+	public void reg(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("properties access does not support registering events").arg("param", param).arg("access", this);
+	}
+
+	@Override
+	public void regRemove(EventParam param, EventListener<?> listener) {
+		throw new InvalidOperationException().msg("properties access does not support registering events").arg("param", param).arg("access", this);
+	}
+
+	@Override
+	public void clearValues() {
+		object.clear();
+	}
+
+	@Override
+	public Access select(Object object) {
+		this.object = ParamsUtil.selectObjectForAccess(this, object, FreeObject.class);
+		return this;
+	}
+
+	@Override
+	public Object getSelected() {
+		return object;
+	}
+
+	@Override
+	public Access cloneAccess() {
+		return new FreeAccess(typeName);
+	}
+
+	@Override
+	public Object createAccessee() {
+		return new FreeObject(typeName);
+	}
+
+	@Override
+	public FramsClass getFramsClass() {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public void tryAutoAppend(Object object) {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public int getCompositeParamCount() {
+		return 0;
+	}
+
+	@Override
+	public CompositeParam getCompositeParam(int number) {
+		throw new InvalidOperationException();
+	}
+
+	@Override
+	public ParamBuilder buildParam(ParamBuilder builder) {
+		return builder.name(typeName).type(ObjectParam.class).containedTypeName(typeName);
+	}
+
+	@Override
+	public String toString() {
+		return "FreeAccess[" + typeName + "]";
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/params/FreeObject.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FreeObject.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/params/FreeObject.java	(revision 107)
@@ -0,0 +1,12 @@
+package com.framsticks.params;
+
+public class FreeObject extends MapBasedObject {
+
+	/**
+	 *
+	 */
+	public FreeObject(String framsTypeName) {
+		super(framsTypeName);
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/params/MapBasedObject.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/MapBasedObject.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/params/MapBasedObject.java	(revision 107)
@@ -0,0 +1,55 @@
+package com.framsticks.params;
+
+import java.util.Iterator;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.TreeMap;
+
+import com.framsticks.util.lang.Casting;
+
+public class MapBasedObject implements Iterable<Map.Entry<String, Object>> {
+
+	protected final String framsTypeName;
+	protected final Map<String, Object> values = new TreeMap<>();
+
+	/**
+	 * @param framsTypeName
+	 */
+	public MapBasedObject(String framsTypeName) {
+		this.framsTypeName = framsTypeName;
+	}
+
+	public <T> void set(String id, T value) {
+		values.put(id, value);
+	}
+
+	public <T> T get(String id, Class<T> type) {
+		return Casting.nullOrThrowCast(type, values.get(id));
+	}
+
+	public void clear() {
+		values.clear();
+	}
+
+	public int size() {
+		return values.size();
+	}
+
+	@Override
+	public String toString() {
+		return values.toString();
+	}
+
+	/**
+	 * @return the framsTypeName
+	 */
+	public String getFramsTypeName() {
+		return framsTypeName;
+	}
+
+	@Override
+	public Iterator<Entry<String, Object>> iterator() {
+		return values.entrySet().iterator();
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/params/OpaqueObject.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/OpaqueObject.java	(revision 107)
+++ /java/main/src/main/java/com/framsticks/params/OpaqueObject.java	(revision 107)
@@ -0,0 +1,49 @@
+package com.framsticks.params;
+
+public class OpaqueObject {
+
+	protected final String typeName;
+	protected final long address;
+
+	/**
+	 * @param typeName
+	 * @param address
+	 */
+	public OpaqueObject(String typeName, long address) {
+		this.typeName = typeName;
+		this.address = address;
+	}
+
+	@Override
+	public String toString() {
+		return typeName + "<0x" + Long.toHexString(address) + ">";
+	}
+
+	/**
+	 * @return the typeName
+	 */
+	public String getTypeName() {
+		return typeName;
+	}
+
+	/**
+	 * @return the address
+	 */
+	public long getAddress() {
+		return address;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (!(obj instanceof OpaqueObject)) {
+			return false;
+		}
+		OpaqueObject opaque = (OpaqueObject) obj;
+		return typeName.equals(opaque.getTypeName()) && address == opaque.getAddress();
+	}
+
+	@Override
+	public int hashCode() {
+		return typeName.hashCode() ^ new Long(address).hashCode();
+	}
+}
Index: /java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 107)
@@ -80,4 +80,5 @@
 	protected final OneTime<Method> remover = new OneTime<>("remover");
 	protected final OneTime<Class<? extends Param>> paramType = new OneTime<>("paramType");
+	protected final OneTime<String> stringType = new OneTime<>("stringType");
 
 	protected int flags = 0;
@@ -278,4 +279,7 @@
 		if (!paramAnnotation.paramType().equals(Param.class)) {
 			paramType.set(paramAnnotation.paramType());
+		}
+		if (!"".equals(paramAnnotation.stringType())) {
+			stringType.set(paramAnnotation.stringType());
 		}
 		if (member instanceof Field) {
@@ -371,4 +375,5 @@
 		protected final List<ParamCandidate> order;
 		protected final java.util.Set<Class<?>> dependantClasses = new HashSet<>();
+		protected final java.util.Set<String> dependantClassesFromInfo = new HashSet<>();
 
 		/**
@@ -398,4 +403,8 @@
 			return dependantClasses;
 		}
+
+		public java.util.Set<String> getDependentClassesFromInfo() {
+			return dependantClassesFromInfo;
+		}
 	}
 
@@ -432,5 +441,7 @@
 					result.dependantClasses.add(r);
 				}
-
+				for (String i : fa.registerFromInfo()) {
+					result.dependantClassesFromInfo.add(i);
+				}
 
 				final List<String> order = Arrays.asList(fa.order());
@@ -575,4 +586,9 @@
 
 	public ParamBuilder induceParamType(ParamBuilder builder) {
+
+		if (stringType.has()) {
+			return builder.type(stringType.get());
+		}
+
 		Method method = getCaller();
 		if (method == null) {
Index: /java/main/src/main/java/com/framsticks/params/ParamsUtil.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/ParamsUtil.java	(revision 107)
@@ -2,10 +2,18 @@
 
 import java.util.ArrayList;
+// import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import java.util.TreeMap;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
 
 import javax.annotation.Nonnull;
 
+// import org.apache.logging.log4j.Logger;
+// import org.apache.logging.log4j.LogManager;
+
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Numbers;
 
 
@@ -16,4 +24,6 @@
  */
 public abstract class ParamsUtil {
+	// private final static Logger log = LogManager.getLogger(ParamsUtil.class.getName());
+
 
 	public static String readSourceToString(Source source) {
@@ -212,4 +222,8 @@
 				return true;
 			}
+			if (type.equals(OpaqueObject.class)) {
+				builder.append(value.toString());
+				return true;
+			}
 			throw new FramsticksException().msg("invalid type for serialization").arg("type", type);
 		}
@@ -233,6 +247,202 @@
 	}
 
+	public static class DeserializationContext {
+
+		public static final Pattern OPAQUE_OBJECT_PATTERN = Pattern.compile("^(\\w+)<0x([a-fA-F0-9]+)>$");
+
+		@SuppressWarnings("serial")
+		public static class Exception extends FramsticksException {
+		}
+
+		protected final ArrayList<Object> objects = new ArrayList<>();
+		protected int cursor = 0;
+		protected final String input;
+
+		/**
+		 * @param input
+		 */
+		public DeserializationContext(String input) {
+			this.input = input;
+			cursor = 0;
+		}
+
+		protected boolean isFinished() {
+			return cursor == input.length();
+		}
+
+		protected boolean is(char value) {
+			if (isFinished()) {
+				throw fail().msg("input ended");
+			}
+			return input.charAt(cursor) == value;
+		}
+
+		protected boolean isOneOf(String values) {
+			if (isFinished()) {
+				throw fail().msg("input ended");
+			}
+			return values.indexOf(input.charAt(cursor)) != -1;
+		}
+
+		protected char at() {
+			return input.charAt(cursor);
+		}
+
+		protected char at(int pos) {
+			return input.charAt(pos);
+		}
+
+		protected FramsticksException fail() {
+			return new Exception().arg("at", cursor).arg("input", input);
+		}
+
+		protected void force(char value) {
+			if (!is(value)) {
+				throw fail().msg("invalid character").arg("expected", value).arg("found", at());
+			}
+			next();
+		}
+
+		protected boolean isAndNext(char value) {
+			if (!is(value)) {
+				return false;
+			}
+			next();
+			return true;
+		}
+
+		protected void next() {
+			++cursor;
+			// log.info("at: {}|{}", input.substring(0, cursor), input.substring(cursor));
+		}
+
+		protected void goToNext(char value) {
+			while (cursor < input.length()) {
+				if (is(value)) {
+					return;
+				}
+				next();
+			}
+			throw fail().msg("passed end").arg("searching", value);
+		}
+
+
+		protected String forceStringRemaining() {
+			int start = cursor;
+			while (true) {
+				goToNext('"');
+				if (at(cursor - 1) != '\\') {
+					next();
+					return input.substring(start, cursor - 1);
+				}
+				next();
+				// it is finishing that loop, because of throwing in goToNext()
+			}
+			// throw fail();
+		}
+
+		public Object deserialize() {
+			if (isAndNext('[')) {
+				List<Object> list = new ArrayList<>();
+				objects.add(list);
+				while (!isAndNext(']')) {
+					if (!list.isEmpty()) {
+						force(',');
+					}
+					Object child = deserialize();
+					list.add(child);
+				}
+				return list;
+			}
+
+			if (isAndNext('{')) {
+				Map<String, Object> map = new TreeMap<>();
+				objects.add(map);
+				while (!isAndNext('}')) {
+					if (!map.isEmpty()) {
+						force(',');
+					}
+					force('"');
+					String key = forceStringRemaining();
+					force(':');
+					Object value = deserialize();
+					map.put(key, value);
+				}
+				return map;
+			}
+
+			if (isAndNext('"')) {
+				return forceStringRemaining();
+			}
+			int start = cursor;
+			while (!isFinished() && !isOneOf("]},")) {
+				next();
+			}
+			if (start == cursor) {
+				throw fail().msg("empty value");
+			}
+
+			String value = input.substring(start, cursor);
+			if (value.equals("null")) {
+				//TODO: add this to list?
+				return null;
+			}
+
+			Matcher matcher = OPAQUE_OBJECT_PATTERN.matcher(value);
+			if (matcher.matches()) {
+				return new OpaqueObject(matcher.group(1), Long.parseLong(matcher.group(2), 16));
+			}
+
+
+			Object number = DeserializationContext.tryParseNumber(value);
+			if (number != null) {
+				return number;
+			}
+
+			if (value.charAt(0) == '^') {
+				Integer reference = Numbers.parse(value.substring(1), Integer.class);
+				if (reference == null) {
+					throw fail().msg("invalid reference").arg("reference", reference);
+				}
+				return objects.get(reference);
+			}
+			//TODO: parse ^
+			//TODO: parse opaque object
+			throw fail().msg("unknown entity");
+
+		}
+
+		public static Object tryParseNumber(String value) {
+			Integer i = Numbers.parse(value, Integer.class);
+			if (i != null) {
+				return i;
+			}
+
+			Double d = Numbers.parse(value, Double.class);
+			if (d != null) {
+				return d;
+			}
+
+			return null;
+		}
+	}
+
+
+	public static Object deserialize(String value) {
+		Object number = DeserializationContext.tryParseNumber(value);
+		if (number != null) {
+			return number;
+		}
+
+		if (!value.startsWith(SERIALIZED)) {
+			return value;
+		}
+		return new DeserializationContext(value.substring(SERIALIZED.length())).deserialize();
+	}
+
 	public static <T> T deserialize(String value, Class<T> type) {
-		return null;
+		Object object = deserialize(value);
+
+		return type.cast(object);
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/PrimitiveParam.java	(revision 107)
@@ -3,5 +3,4 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
-import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Numbers;
 import com.framsticks.util.lang.Strings;
@@ -51,13 +50,12 @@
 					return type.cast(value);
 				}
-				// if (Number.class.isAssignableFrom(type)) {
 				return Numbers.parse((String) value, type);
-				// }
-				// return null;
+			} if ((value instanceof Integer) && (type.equals(Double.class))) {
+				return type.cast(new Double((Integer) value));
 			} else {
 				return type.cast(value);
 			}
 		} catch (ClassCastException e) {
-			throw new FramsticksException().msg("failed to cast").cause(e).arg("param", this).arg("actual", value.getClass()).arg("requested", type);
+			throw new FramsticksException().msg("failed to cast").cause(e).arg("param", this).arg("actual", value.getClass()).arg("requested", type).arg("value", value);
 		}
 	}
@@ -99,16 +97,7 @@
 	}
 
-	@Override
 	public <T> String serialize(T value) {
 		return Strings.toStringNullProof(value);
 	}
 
-	@Override
-	public <T> T deserialize(String text, T currentValue, Class<T> type) {
-		try {
-			return Casting.nullOrThrowCast(type, reassign(text, currentValue).getValue());
-		} catch (CastFailure e) {
-			return null;
-		}
-	}
 }
Index: /java/main/src/main/java/com/framsticks/params/PropertiesObject.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/PropertiesObject.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/PropertiesObject.java	(revision 107)
@@ -1,47 +1,12 @@
 package com.framsticks.params;
 
-import java.util.Map;
-import java.util.TreeMap;
-
-import com.framsticks.util.lang.Casting;
-
-public class PropertiesObject {
-
-	protected final String framsTypeName;
-	protected final Map<String, Object> values = new TreeMap<>();
+public class PropertiesObject extends MapBasedObject {
 
 	/**
-	 * @param framsTypeName
+	 *
 	 */
 	public PropertiesObject(String framsTypeName) {
-		this.framsTypeName = framsTypeName;
+		super(framsTypeName);
 	}
 
-	public <T> void set(String id, T value) {
-		values.put(id, value);
-	}
-
-	public <T> T get(String id, Class<T> type) {
-		return Casting.nullOrThrowCast(type, values.get(id));
-	}
-
-	public void clear() {
-		values.clear();
-	}
-
-	public int size() {
-		return values.size();
-	}
-
-	@Override
-	public String toString() {
-		return values.toString();
-	}
-
-	/**
-	 * @return the framsTypeName
-	 */
-	public String getFramsTypeName() {
-		return framsTypeName;
-	}
 }
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 107)
@@ -11,4 +11,5 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 
 import static com.framsticks.util.lang.Containers.*;
@@ -90,5 +91,5 @@
 			}
 		} catch (FramsticksException e) {
-			throw e.arg("param", param).arg("value", value).arg("access", this);
+			throw e.arg("param", param).arg("value", value).arg("value type", Misc.getClass(value)).arg("access", this);
 		}
 	}
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 107)
@@ -8,4 +8,5 @@
 import com.framsticks.util.DoubleMap;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Strings;
 
@@ -53,4 +54,8 @@
 			registerAndBuild(r);
 		}
+
+		for (String i : ParamCandidate.getAllCandidates(javaClass).getDependentClassesFromInfo()) {
+			putFramsClass(FramsClassBuilder.readFromStream(getClass().getResourceAsStream("/info/" + i + ".info")));
+		}
 		return this;
 	}
@@ -76,4 +81,8 @@
 		try {
 			if (!javaClasses.containsValue(javaClass)) {
+				registerAndBuild(javaClass);
+			}
+
+			if (!javaClasses.containsValue(javaClass)) {
 				throw new FramsticksException().msg("java class is not registered");
 			}
@@ -114,14 +123,24 @@
 	}
 
-	public @Nonnull Access prepareAccess(CompositeParam param) throws ConstructionException {
-		return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
-	}
-
-	public @Nonnull Access createAccess(@Nonnull String name) throws ConstructionException {
+	public @Nonnull Access prepareAccess(CompositeParam param, boolean force) throws ConstructionException {
+		return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName(), force));
+	}
+
+	public @Nonnull Access createAccess(@Nonnull Object object) throws ConstructionException {
+		if (object instanceof MapBasedObject) {
+			return createAccess(((MapBasedObject) object).getFramsTypeName());
+		}
+		return createAccess(object.getClass());
+	}
+
+	public @Nonnull Access createAccess(@Nonnull String name, boolean force) throws ConstructionException {
 		try {
 			Strings.assureNotEmpty(name);
 			FramsClass framsClass = getFramsClass(name);
 			if (framsClass == null) {
-				throw new ConstructionException().msg("framsclass is missing");
+				if (!force) {
+					throw new ConstructionException().msg("framsclass is missing");
+				}
+				return new FreeAccess(name);
 			}
 
@@ -131,4 +150,8 @@
 			throw new FramsticksException().msg("failed to create access for name").arg("name", name).cause(e);
 		}
+	}
+
+	public @Nonnull Access createAccess(@Nonnull String name) throws ConstructionException {
+		return createAccess(name, false);
 	}
 
@@ -166,5 +189,21 @@
 
 	public Access bindAccessFor(Object object) {
-		return createAccess(object.getClass()).select(object);
+		return createAccess(object).select(object);
+	}
+
+	public Registry register(ParamsPackage paramsPackage) {
+		paramsPackage.register(this);
+		return this;
+	}
+
+	public Registry registerAndBuild(ParamsPackage paramsPackage) {
+		paramsPackage.setBuild(true);
+		paramsPackage.register(this);
+		return this;
+	}
+
+	public Access bindAccessFor(Access parent, String paramName) {
+		CompositeParam childParam = Casting.throwCast(CompositeParam.class, parent.getParam(paramName));
+		return prepareAccess(childParam, true).select(parent.get(childParam, Object.class));
 	}
 
Index: /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 107)
@@ -187,10 +187,28 @@
 	}
 
+	public int setUidOf(Object value, String uid) {
+		return uidAccess.select(value).set(uidName, uid);
+	}
+
+	protected int uidCounter = 1;
+
+	public String generateNextUid() {
+		return containedTypeName.substring(0, 1).toUpperCase() + Integer.toString(uidCounter++);
+	}
+
+	public String findNextFreeUid() {
+		String uid;
+		do {
+			uid = generateNextUid();
+		} while (get(uid, Object.class) != null);
+		return uid;
+	}
+
 	protected int setByUid(Object object, String uid) {
 		if (uid == null) {
 			uid = getUidOf(object);
 			if (uid == null) {
-				log.error("failed to set - missing uid");
-				return 0;
+				uid = findNextFreeUid();
+				setUidOf(object, uid);
 			}
 		}
@@ -205,13 +223,23 @@
 	@Override
 	public <T> int set(int i, T value) {
-		if (i != map.size()) {
-			throw new FramsticksUnsupportedOperationException().msg("setting element in unique list through index is available only for addition");
-		}
-		set(getUidOf(value), value);
-		return 0;
+		if (value != null) {
+			if (i != map.size()) {
+				throw new FramsticksUnsupportedOperationException().msg("setting element in unique list through index is available only for addition");
+			}
+			set(getUidOf(value), value);
+			return 0;
+		}
+		if (i >= map.size()) {
+			throw new FramsticksUnsupportedOperationException().msg("invalid index for removal");
+		}
+		Object current = get(i, Object.class);
+		return setByUid(null, getUidOf(current));
 	}
 
 	@Override
 	public <T> int set(String id, T value) {
+		if (id == null) {
+			return setByUid(value, null);
+		}
 		Integer i = Numbers.parse(id, Integer.class);
 		if (i != null) {
Index: /java/main/src/main/java/com/framsticks/params/ValueParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 107)
@@ -28,7 +28,5 @@
 	}
 
-	public abstract <T> String serialize(T value);
-
-	public abstract <T> T deserialize(String text, T currentValue, Class<T> type);
+	// public abstract <T> String serialize(T value);
 
 }
Index: /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 107)
@@ -14,3 +14,4 @@
 	String[] order() default {};
 	Class<?>[] register() default {};
+	String[] registerFromInfo() default {};
 }
Index: /java/main/src/main/java/com/framsticks/params/types/ListParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 107)
@@ -16,12 +16,8 @@
 	}
 
-	@Override
-	public <T> String serialize(T value) {
-		return null;
-	}
+	// @Override
+	// public <T> String serialize(T value) {
+	// 	return null;
+	// }
 
-	@Override
-	public <T> T deserialize(String text, T currentValue, Class<T> type) {
-		return null;
-	}
 }
Index: /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 106)
+++ /java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 107)
@@ -5,5 +5,4 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.ParamBuilder;
-import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.ReassignResult;
 
@@ -51,13 +50,8 @@
 	}
 
-	@Override
-	public <T> String serialize(T value) {
-		return ParamsUtil.serialize(value);
-	}
-
-	@Override
-	public <T> T deserialize(String text, T currentValue, Class<T> type) {
-		return ParamsUtil.deserialize(text, type);
-	}
+	// @Override
+	// public <T> String serialize(T value) {
+	// 	return ParamsUtil.serialize(value);
+	// }
 
 }
